<?php
namespace Teknisa\PLA\Modules\Requisicao\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;

class Pla03800HistoricoDeRequisicao extends \Zeedhi\Framework\Controller\Report {

    protected $reportService;
    protected $dataSourceManager;
    protected $qr2Strategy;
    
    public function __construct($reportService, $dataSourceManager, $qr2Strategy) {
      parent::__construct($reportService);
      $this->dataSourceManager = $dataSourceManager;
      $this->qr2Strategy = $qr2Strategy;
    }

    protected $reportMapping = array (
        'Pla03800' => array (
            'strategy' => 'QR2',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_TCDOPERADOR'   => 'P_TCDOPERADOR',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI'
            )
        ),
        'Pla03802' =>  array (
            'strategy' => 'QR2',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_TCDOPERADOR'   => 'P_TCDOPERADOR',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI'
            )
        ),
        'Pla03803' => array (
            'strategy' => 'QR2',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_TCDOPERADOR'   => 'P_TCDOPERADOR',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI'
            )
        ),
        'Pla03801' => array (
            'strategy' => 'QR2',
            'parameterMapping' => array (
                'P_CDSERVFILI'    => 'P_CDSERVICO',
                'P_TCDOPERADOR'   => 'P_TCDOPERADOR',
                'P_CDOPERADOR'    => 'P_CDOPERADOR',
                'P_CDFILIAL'      => 'P_CDFILIAL',
                'P_DATAFIN'       => 'P_DTFIN',
                'P_DATAINI'       => 'P_DTINI'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();
        if ($row['P_CDSERVFILI'] == 'T') {
            $this->mountListaServ($row);
        }
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }

    public function mountListaServ($row) {
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $row['P_CDFILIAL'],
            ),
            array(
                'columnName' => 'NRORG',
                'operator' => '=',
                'value' => $row['NRORG'],
            )
        );

        $filterCriteria = new FilterCriteria('servico', $conditions);
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);

        $servicos = $dataSet->getRows();
        $row['P_CDSERVFILI'] = '';
        foreach($servicos as $servico){
            $row['P_CDSERVFILI'] = $row['P_CDSERVFILI'].'_'.$servico['CDSERVFILI'];
        }
    }
}